require 'active_support/core_ext/module'
require 'digest'
require 'rufus-lua'

require "torchrb/version"

require 'torchrb/lua'
require 'torchrb/torch'
require 'torchrb/wrapper'
require 'torchrb/data_set'
require 'torchrb/model_base'
require 'torchrb/nn/basic'
require 'torchrb/nn/trainer_default'
require 'torchrb/nn/image_default'

module Torchrb

  module_function
  def train model_class
    Torchrb::Wrapper.for model_class do |model|
      model.load_model_data
      model.train
    end
  end

  def predict sample
    Torchrb::Wrapper.for sample.class do |model|
      model.predict sample
    end
  end

end
